/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pb138.domtest;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author bar
 */
public class DomTest {
    
    private Document doc=null;

    public static void main(String[] args){
        try {
            DomTest domTest = new DomTest("books.xml");
            domTest.changeAuthor("O. Sekora","Ondrej Sekora");
            System.out.println("Pocet stran v knizkach:" + domTest.countPages());
            domTest.removeUnknownAuthors();
            domTest.serialize("out.xml");
        } catch (TransformerConfigurationException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            System.err.println("Nevalidni dokument.");
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        }

        
    }
/**
 * Counts the total number of pages in the bookshell
 * @return number of pages
 */
    public int countPages(){
        int pages = 0;
        
        NodeList pageElements = doc.getElementsByTagName("pages");
        for(int i=0;i<pageElements.getLength();i++)
        {
            Node pageElement = pageElements.item(i);
            String strValue = pageElement.getTextContent();
            pages += Integer.parseInt(strValue);
        }
	return pages;
    }
            
    /**
     * Changes all occurancies of oldName in the element author to a newName
     * @param oldName original name of the author
     * @param newName new name of the author
     */
    public void changeAuthor(String oldName, String newName) {
	NodeList authors = doc.getElementsByTagName("author");
        for(int i = 0 ; i < authors.getLength() ; i++ ){
            Node author = authors.item(i);
            String name = author.getTextContent();
            if(name.equalsIgnoreCase(oldName)){
                author.setTextContent(newName);
            }
        }
    }
    /**
     * Constructor. Loads the content of the file into internal DOM Document representation.
     * @param fileName name of the input file
     * @throws ParserConfigurationException
     * @throws SAXException
     * @throws IOException 
     */
    public DomTest(String fileName) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        
        dbf.setValidating(true);

        DocumentBuilder docBuilder = dbf.newDocumentBuilder();
        docBuilder.setErrorHandler(new ErrorHandler(){

            public void warning(SAXParseException exception) throws SAXException {
                System.err.println("Varovani: " + exception.getLocalizedMessage());
            }

            public void error(SAXParseException exception) throws SAXException {
                System.err.println("Chyba:" + exception.getLocalizedMessage());
            }

            public void fatalError(SAXParseException exception) throws SAXException {
                System.err.println("Hruba chyba: " + exception.getLocalizedMessage());
            }
        });
        
        doc = docBuilder.parse(fileName);
    }

    
    /**
     * Stores the internal DOM Document representation into the XML file
     * @param output name of the output XML file
     * @throws TransformerConfigurationException
     * @throws TransformerException 
     */
    public void serialize(String output) throws TransformerConfigurationException, TransformerException{
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer trans = tf.newTransformer();

        Source source = new DOMSource(doc.getDocumentElement());
        Result result = new StreamResult(output);

        trans.transform(source, result);
    }

    public void removeUnknownAuthors() {
        NodeList books = doc.getElementsByTagName("book");
        List<Node> booksToRemove = new ArrayList<Node>();
        
        for(int i = 0 ; i < books.getLength() ; i++)
        {
            Element book = (Element)books.item(i);
            NodeList authors = book.getElementsByTagName("author");
            for(int j = 0; j < authors.getLength() ; j++ ){
                String author = authors.item(j).getTextContent();
                if(author.equalsIgnoreCase("Neznamy")){
                    //booksToRemove.add(book);
                    book.getParentNode().removeChild(book);
                }
            }
        }
        removeBooks(booksToRemove);
    }

    public void removeBooks(List<Node> booksToRemove) {
        NodeList books = doc.getElementsByTagName("books");
        for(int i=0 ; i<books.getLength() ; i++)
        {
            Element booksAdept = (Element)books.item(i); 
            for(Node book:booksToRemove){
                try{
                    NodeList childBooks = books.item(i).getChildNodes();
                    booksAdept.removeChild(book);
                }catch(DOMException ex){
                }
                
                
            }
        }
    }
    
    

}
